//
//  ViewController.swift
//  SwiftFrom
//
//  Created by 刘春雷 on 2019/9/6.
//  Copyright © 2019 刘春雷. All rights reserved.
//

import UIKit

class ViewController: FormViewController {
    let pickerOptions = ["博士", "研究生", "本科","专科","高中","高中以下"] as [AnyObject]
    
    struct Static {
        static let nameTag = "name"
        static let labelTag = "label"
        static let passwordTag = "password"
        static let lastNameTag = "lastName"
        static let jobTag = "job"
        static let emailTag = "email"
        static let URLTag = "url"
        static let phoneTag = "phone"
        static let enabled = "enabled"
        static let check = "check"
        static let segmented = "segmented"
        static let picker = "picker"
        static let birthday = "birthday"
        static let categories = "categories"
        static let button = "button"
        static let stepper = "stepper"
        static let slider = "slider"
        static let textView = "textview"
        static let address = "adress"
    }
    var myProvince : String?
    var myCity: String?
    var myArea: String?
    var str: String?
    override func viewDidLoad() {
        //该方法必须在父viewDidLoad之前调用
        self.loadForm()
        super.viewDidLoad()
        self.view.backgroundColor = UIColor.white
        self.navigationItem.rightBarButtonItem = UIBarButtonItem(title: "Submit", style: .plain, target: self, action: #selector(ViewController.submit(_:)))
        NotificationCenter.default.addObserver(self, selector: #selector(test), name: NSNotification.Name(rawValue: "clickButton"), object: nil)
    }
    @objc func test(nofi : NSNotification) {
        let address = KLCityPickerView()
        address.areaPickerViewWithProvince(province: myProvince, city: myCity, area: myArea) { (province, city, area) in
            self.myProvince = province
            self.myCity = city
            self.myArea = area
            print("\(province)\(city)\(area)")
        }
    }
    // MARK: Actions
    
    @objc func submit(_: UIBarButtonItem!) {

        
        let message = self.form.formValues().description

        let alertController = UIAlertController(title: "Form output", message: message, preferredStyle: .alert)

        let cancel = UIAlertAction(title: "OK", style: .cancel) { (action) in
        }

        alertController.addAction(cancel)

        self.present(alertController, animated: true, completion: nil)
    }
    
    // MARK: Private interface
    
    fileprivate func loadForm() {
        
        let form = FormDescriptor(title: "Example Form")
        
        let section1 = FormSectionDescriptor(headerTitle: nil, footerTitle: nil)
        
        var row = FormRowDescriptor(tag: Static.emailTag, type: .email, title: "邮箱")
        row.configuration.cell.appearance = ["textField.placeholder" : "请输入邮箱" as AnyObject, "textField.textAlignment" : NSTextAlignment.right.rawValue as AnyObject ]
        row.configuration.cell.placeholder = "请输入邮箱"
        section1.rows.append(row)
        
        row = FormRowDescriptor(tag: Static.passwordTag, type: .password, title: "密码")
        row.configuration.cell.appearance = ["textField.placeholder" : "请输入密码" as AnyObject, "textField.textAlignment" : NSTextAlignment.right.rawValue as AnyObject]
        row.configuration.cell.placeholder = "密码"
        section1.rows.append(row)
        
        row = FormRowDescriptor(tag: Static.phoneTag, type: .phone, title: "手机号")
        row.configuration.cell.appearance = ["textField.placeholder" : "请输入手机号" as AnyObject, "textField.textAlignment" : NSTextAlignment.right.rawValue as AnyObject]
        row.configuration.cell.placeholder = "请输入手机号"
        section1.rows.append(row)
        
        row = FormRowDescriptor(tag: Static.labelTag, type: .label, title: "不可编辑")
        row.configuration.cell.placeholder = "张三"

        section1.rows.append(row)

        
        row = FormRowDescriptor(tag: Static.picker, type: .picker, title: "性别")
        row.configuration.cell.showsInputToolbar = true
        row.configuration.selection.options = (["F", "M"] as [String]) as [AnyObject]
        row.configuration.selection.optionTitleClosure = { value in
            guard let option = value as? String else { return "" }
            switch option {
            case "F":
                return "男"
            case "M":
                return "女"
            case "U":
                return "I'd rather not to say"
            default:
                return ""
            }
        }
        
        row.value = "F" as AnyObject
        
        section1.rows.append(row)
        
        row = FormRowDescriptor(tag: Static.birthday, type: .date, title: "生日")
        row.configuration.cell.showsInputToolbar = true
        section1.rows.append(row)
        
        row = FormRowDescriptor(tag: Static.categories, type: .multipleSelector, title: "多选")
        row.configuration.selection.options = ([0, 1, 2, 3, 4] as [Int]) as [AnyObject]
        row.configuration.selection.allowsMultipleSelection = true
        row.configuration.selection.optionTitleClosure = { value in
            guard let option = value as? Int else { return "" }
            switch option {
            case 0:
                return "红色"
            case 1:
                return "绿色"
            case 2:
                return "白色"
            case 3:
                return "蓝色"
            case 4:
                return "黄色"
            default:
                return ""
            }
        }
        
        section1.rows.append(row)
        
        row = FormRowDescriptor(tag: Static.picker, type: .picker, title: "学历")
        row.configuration.cell.showsInputToolbar = true
        row.configuration.selection.options = pickerOptions
        row.configuration.selection.optionTitleClosure = { value in
            guard let option = value as? String else { return "" }
            return option
        }
        row.value = pickerOptions[02] as AnyObject
        row.configuration.cell.appearance = [
            "valueLabel.accessibilityIdentifier": "PickerTextFied" as AnyObject]
        section1.rows.append(row)
        

        row = FormRowDescriptor(tag: Static.address, type: .address, title: "地址")
        row.configuration.cell.showsInputToolbar = true
        section1.rows.append(row)
        
        row = FormRowDescriptor(tag: Static.textView, type: .multilineText, title: "备注")
        row.configuration.cell.appearance = ["textField.textColor": UIColor.black,
                                             "textField.text": "这是一个文档备注说明" as AnyObject]
        section1.rows.append(row)
        
        
  
        
      
        row = FormRowDescriptor(tag: Static.button, type: .button, title: "按钮")
        row.configuration.button.didSelectClosure = { _ in
            self.view.endEditing(true)
        }
        section1.rows.append(row)
        
        form.sections = [section1]
        
        self.form = form
    }
}

