//
//  FormDescriptor.swift
//  SwiftFrom
//
//  Created by 刘春雷 on 2019/9/9.
//  Copyright © 2019 刘春雷. All rights reserved.
//

import UIKit

public final class FormDescriptor {
    
    // MARK: Properties
    
    public var title: String
    public var sections: [FormSectionDescriptor] = []
    
    // MARK: Init
    
    public init() {
        self.title = ""
    }
    
    public init(title: String) {
        self.title = title
    }
    
    // MARK: Public
    
    public func formValues() -> [String : AnyObject] {
        
        var formValues: [String : AnyObject] = [:]
        
        for section in sections {
            for row in section.rows {
                if row.type != .button {
                    if let value = row.value {
                        formValues[row.tag] = value
                    } else {
                        formValues[row.tag] = NSNull()
                    }
                }
            }
        }
        return formValues
    }
    
    public func validateForm() -> FormRowDescriptor? {
        for section in sections {
            for row in section.rows {
                if row.configuration.cell.required && row.value == nil {
                    return row
                }
            }
        }
        return nil
    }
}
